unit UnidadProcedimientos;

interface

function ObtenerWeb(webIP : string) : string;
function obtenerURLdeIP (ip : string) : string;
function obtenerEtiqueta (contenidoWeb : string; etiquetaIni : string; etiquetaFin : string) : string;
function obtenerIPdeURL (url : string) : string;

var
  errorCaptura : string;
  numErrores : double;
  numAciertos : double;

implementation


uses  IdHTTP, Classes, Sockets, SysUtils;


//Obtener IP pblica pc local
function ObtenerWeb(webIP : string) : string;
var
  obtenerHTTP : TidHTTP;
  web : TStringList;
begin
  errorCaptura := '';
  web := TStringList.Create;
  obtenerHTTP := TidHTTP.Create(nil);
  try
    web.Text := obtenerHTTP.Get('http://' + webIP);
    numAciertos := numAciertos + 1;
  except
    on e: exception do
    begin
      errorCaptura := e.Message;
      numErrores := numErrores + 1;
      obtenerHTTP.Free;
    end;
  end;
  ObtenerWeb := web.Text;
end;

function obtenerTagWeb (contenido : string) : string;
begin
//
end;

//obtiene la URL de una IP
function obtenerURLdeIP (ip : string) : string;
var
  ctURL : TTcpServer;
begin
  ctURL := TTCPServer.Create (nil);
  obtenerURLdeIP := ctURL.LookupHostName (ip);
end;

//obtiene la IP de una URL
function obtenerIPdeURL (url : string) : string;
var
  ctURL : TTcpServer;
begin
  ctURL := TTCPServer.Create (nil);
  obtenerIPdeURL := ctURL.LookupHostAddr (url);
end;

function obtenerEtiqueta (contenidoWeb : string; etiquetaIni : string; etiquetaFin : string) : string;
var
  lineas : TStringList;
  i : integer;
  titulo, lineaActual : string;
begin
  lineas := TStringList.Create;
  lineas.Text := contenidoWeb;
  titulo := '';
  etiquetaIni := AnsiUpperCase(etiquetaIni);
  etiquetaFin := AnsiUpperCase(etiquetaFin);
  for i := 0 to lineas.Count - 1 do
  begin
    lineaActual := lineas.Strings[i];
    //si encuentra las dos etiquetas en la misma lnea
    if (Pos (etiquetaIni, AnsiUpperCase(lineaActual)) <> 0) and (Pos (etiquetaFin, AnsiUpperCase(lineaActual)) <> 0)then
    begin
      titulo := copy (lineaActual,
          Pos (etiquetaIni, AnsiUpperCase(lineaActual)) + length (etiquetaIni),
          Pos (etiquetaFin, AnsiUpperCase(lineaActual)) - length (etiquetaFin) - 1);
      Break;
    end;
    //si en la lnea slo aparece el inicio del ttulo
    if (Pos (etiquetaIni, AnsiUpperCase(lineaActual)) <> 0) and (Pos (etiquetaFin, AnsiUpperCase(lineaActual)) = 0)then
    begin
      titulo := copy (lineaActual, Pos (etiquetaIni, AnsiUpperCase(lineaActual)), length(lineaActual));
    end;
    //si en la lnea slo aparece el fin del ttulo
    if (Pos (etiquetaIni, AnsiUpperCase(lineaActual)) = 0) and (Pos (etiquetaFin, lineaActual) <> 0)then
    begin
      titulo := titulo + copy (lineaActual, Pos (etiquetaFin, AnsiUpperCase(lineaActual)), length(lineaActual));
      break;
    end;
  end;
  obtenerEtiqueta := titulo;
end;

end.
